@echo off
rem erzeugt aus einem vorhandenen FOSHKplugin-LoxBerry-Plugin ein geclontes Plugin zur parallelen Installation im LoxBerry
rem Aufruf:
rem cloneFOSHKplugin.bat inputdatei newsvcname newsvctitle
rem wenn 2. und 3. Parameter (Service-Name und Plugin-Titel) vorhanden, dann nehmen ansonsten abfragen
rem Oliver Engel, 07.03.2022
set prgname=FOSHKpluginService.bat
set prgver=v0.1
set svcname=foshkplugin
set newsvcname=foshkplugin2
set newsvctitle=FOSHKplugin2
setlocal enabledelayedexpansion

cls
echo.
echo Phantasoft FOSHKplugin-Plugin-Cloner %prgver%
echo =========================================
echo.

rem check parameters
set argC=0
for %%x in (%*) do Set /A argC+=1
if %argC% LSS 1 (
  echo Please call this script with parameters - use at least the zipname you want to use as the source:
  echo.
  echo %prgname% zipname [newsvcname newtitle]
  echo.
  echo You have to specify the filename of the zip containing the FOSHKplugin LoxBerry plugin!
  echo.
  echo Please press a key
  goto ende
) else (
  set iszip=%1
  if %argC% == 3 (
    set newsvcname=%2
    set newsvctitle=%3
  ) else (
    echo FOSHKplugin needs a unique name for the additonal service
    echo just press ENTER to use the default name %newsvcname%
    echo.
    set /p newsvcname="Please specify this name [%newsvcname%]: "
    echo.
    echo FOSHKplugin needs also a unique title for this additional service
    echo press ENTER to use the default title %newsvctitle%
    echo.
    set /p newsvctitle="Please specify the title for this [%newsvctitle%]: "
    echo.
  )
)

rem make sure the complete file path is present
for %%i in ("%iszip%") do ( set iszip=%%~fi ) 

if not exist %iszip% (
  echo.
  echo file %iszip% not found!
  echo nothing done, press a key
  goto ende
)

set "dst=%TEMP%\%newsvcname%"
set "src=%iszip%"
if not exist "!dst!\" mkdir "!dst!" > nul

rem create and run extracting script (VBS)
set "U=%TEMP%\unzipFOSHKplugin.vbs"
echo extracting !src!
>"!U!" echo CreateObject^(^"Shell.Application^"^).Namespace^("%dst%"^).CopyHere CreateObject^(^"Shell.Application^"^).Namespace^("%src%"^).Items, 4 + 16
cscript //nologo "!U!"
echo extracting done

rem copy plugin.cfg to plugin.cfg.orig (if not present)
if not exist "%TEMP%\%newsvcname%\plugin.cfg.orig" (
  echo creating backup file plugin.cfg.orig
  copy "%TEMP%\%newsvcname%\plugin.cfg" "%TEMP%\%newsvcname%\plugin.cfg.orig" > nul
  echo creating backup file plugin.cfg.orig done
)
  
rem patch plugin.cfg
echo adjusting plugin.cfg
set infile=%TEMP%\%newsvcname%\plugin.cfg.orig
set outfile=%TEMP%\%newsvcname%\plugin.cfg
copy nul %outfile% > nul
for /f "tokens=*" %%a in (%infile%) do ( 
  set line=%%a
  set part=!line:~0,6!
  if "!part!" == "TITLE=" (
    echo TITLE=%newsvctitle% >> %outfile%
  ) else (
  if "!part!" == "NAME=f" (
    echo NAME=%newsvcname% >> %outfile%
  ) else (
  if "!part!" == "FOLDER" (
    echo FOLDER=%newsvcname% >> %outfile%
  ) else ( 
    echo !line! >> %outfile%
  )))
)
echo adjusting plugin.cfg done

rem create a new zip file
set newzip=%iszip:FOSHKplugin=FOSHKplugin-!newsvcname!%
echo creating new zip !newzip!
set "U=%TEMP%\unzipFOSHKplugin.vbs"
>"!U!" echo CreateObject^(^"Scripting.FileSystemObject^"^).CreateTextFile^("!newzip!", True^).Write ^"PK^" ^& Chr^(5^) ^& Chr^(6^) ^& String^(18, vbNullChar^)
>>"!U!" echo CreateObject^(^"Shell.Application^"^).NameSpace^("!newzip!"^).CopyHere^(CreateObject^(^"Shell.Application^"^).NameSpace^("!dst!"^).Items^)
>>"!U!" echo wScript.Sleep 3000
cscript //nologo "!U!"
echo creating new zip done

echo.
echo clone FOSHKplugin package done:
echo ZIPFILE = !newzip!
echo NAME    = %newsvcname%
echo TITLE   = %newsvctitle%
echo.
echo You may install this cloned FOSHKplugin on your LoxBerry the usual way!
echo.
echo all done, press a key
endlocal

:ende
pause >nul
